@echo off

rem	OpenEdge does not actually use DLC, PROPATH, PROCFG, or PROMSGS environment variables
rem	they are actually set in etc/protop.ini, we set some of them here for documentation purposes

if "%DLC%"=="" set DLC=#ENVDLC#

set PROTOP=#ENVPT3#
set LOGDIR=#ENVLOG#
set TMPDIR=#ENVTMP#
set RPTDIR=#ENVRPT#
set PROXY=#PROXY#

rem	these are now set in bin\portalenv.bat
rem

rem	set PTHOST=#PTHOST#
rem	set PTUPD=#PTUPD#

rem	OpenEdge does not actually use the PROPATH environment variable - it gets PROPATH from etc/protop.ini

set PROPATH=#ENVPRP#,%PROTOP%
set PT3=%PROTOP%
set DBA=%PROTOP%

REM	there is no need to detect "bitness" or specify the PROPATH, lib/install.p will figure it out and correctly configure etc/protop.ini
REM	
rem	check for a version-specific prolib and set the PROPATH to use it if it exists
rem
REM	
REM	
REM	FOR /F "tokens=* USEBACKQ" %%F IN (`type %DLC%\version ^| ubin\gawk "{ print $3 }" ^| ubin\gawk -F. "{print $1}"`) do (SET PROVERSION=%%F)
REM
REM	set BITS=
REM	
REM	if "%PROVERSION%" == "10" (
REM	
REM		ubin\file %DLC%\bin\_progres.exe | findstr 64 > NUL
REM	
REM		if errorLevel 0 (
REM			set BITS=-64
REM		)
REM	
REM	)
REM
REM	set PT3PROLIB=protop-v%PROVERSION%%BITS%.pl
REM	
REM	if exist %PT3PROLIB% (
REM		set PROPATH=%PT3PROLIB%,%PROTOP%
REM	) else (
REM		set PROPATH=%PROTOP%
REM	)

rem	all modern release of Progress support -errorstack. if you are running
rem	something old and crusty that does not, such as 10.1B, you can override
rem	this in localenv by setting it to blank

set ERRSTACK=-errorstack

rem	for compatibility with the UNIX protopenv
rem

set PTTMP=%TMPDIR%

rem     set the screen to support protop with more than 48 lines
rem     is ok, recommended even - smaller is not
rem
rem     picking a decent font will also help, the default fonts
rem     are awful but lucida 12 and consola 16 are pretty good
rem
rem	(you may also want to adjust protop.ini)
rem
rem     the following is usually appropriate:

set ROWS=72
set COLS=160

rem     while simple, this approach results in PATH constantly growing
rem

rem set PATH=%DLC%\bin;%PROTOP%\bin;%PROTOP%\ubin;%PATH%

rem     more complicated but it preserves whatever the local PATH is ...
rem

rem call "%PROTOP%"\bin\addpath.bat "%DLC%\bin"
rem call "%PROTOP%"\bin\addpath.bat "%PROTOP%\bin"
rem call "%PROTOP%"\bin\addpath.bat "%PROTOP%\ubin"

rem     the local PATH is usually full of junk so the
rem     best option is to just go with the minimum:
rem

set PATH=%DLC%\bin;%PROTOP%\bin;%PROTOP%\ubin;C:\Windows\system32;C:\Windows;C:\Windows\System32\Wbem

rem
rem begin add USESSL changes (build the global portion of PFLIST here instead of individual scripts/bat files to include -certstorepath)
rem
rem     chain together .pf files if they exist
rem
rem           etc/protop.pf
rem           etc/custId.pf
rem           etc/serverName.pf
rem           etc/type.pf		- not global, depends on content of etc/dblist.cfg
rem           etc/friendlyName.pf	- not global, depends on content of etc/dblist.cfg
rem

set PFLIST=

if exist %PROTOP%\etc\protop.pf (
        set PFLIST=%PFLIST% -pf etc\protop.pf
)

set /p CUSTID=<%PROTOP%\etc\custid.cfg
if exist %PROTOP%\etc\%CUSTID%.pf (
        set PFLIST=%PFLIST% -pf etc\%CUSTID%.pf
)

for /F "usebackq" %%i in (`hostname`) do set HOSTNAME=%%i
if exist %PROTOP%\etc\%HOSTNAME%.pf (
        set PFLIST=%PFLIST% -pf etc\%HOSTNAME%.pf
)

rem  end add USESSL changes
rem

if exist %PROTOP%\bin\portalenv.bat (
	call %PROTOP%\bin\portalenv.bat
)

if exist %PROTOP%\bin\dbaenv.bat (
	call %PROTOP%\bin\dbaenv.bat
)

if exist %PROTOP%\bin\localenv.bat (
	call %PROTOP%\bin\localenv.bat
)

mode con cols=%COLS% lines=%ROWS%
